import { BaseBatchUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-batch-update-status.manager';
import { VipCategoryEntity } from '../../entities/vip-category.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { VipCategoryModel } from '../../../data/models/vip-category.model';
import { VipCategoryChangeStatusEvent } from '../../entities/event/vip-category-change-status.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchConfirmVipCategoryManager extends BaseBatchUpdateStatusManager<VipCategoryEntity> {
  validateData(data: VipCategoryEntity): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return VipCategoryModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: VipCategoryChangeStatusEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
